/*
 * This file is part of libdom.
 * Licensed under the MIT License,
 *                http://www.opensource.org/licenses/mit-license.php
 * Copyright 2012 Daniel Silverstone <dsilvers@netsurf-browser.org>
 */

/* Note, this file deliberately lacks guards since it's included many times
 * in many places in order to correctly handle the loading of the strings.
 */

#ifndef HTML_DOCUMENT_STRINGS_ACTION
#define HTML_DOCUMENT_STRINGS_INTERNAL_ACTION 1
#define HTML_DOCUMENT_STRINGS_PREFIX      \
	typedef enum {
#define HTML_DOCUMENT_STRINGS_SUFFIX		\
	hds_COUNT				\
	} html_document_memo_string_e;
#define HTML_DOCUMENT_STRINGS_ACTION(tag)	\
	hds_##tag,
#endif

#ifdef HTML_DOCUMENT_STRINGS_PREFIX
HTML_DOCUMENT_STRINGS_PREFIX
#endif

/* Useful attributes for HTMLElement */
HTML_DOCUMENT_STRINGS_ACTION(id)
HTML_DOCUMENT_STRINGS_ACTION(title)
HTML_DOCUMENT_STRINGS_ACTION(lang)
HTML_DOCUMENT_STRINGS_ACTION(dir)
HTML_DOCUMENT_STRINGS_ACTION(class)
/* Useful attributes used by HTMLHtmlElement */
HTML_DOCUMENT_STRINGS_ACTION(version)
/* Names for elements which get specialised.  Ones commented out are
 * present above.
 */
HTML_DOCUMENT_STRINGS_ACTION(html)
HTML_DOCUMENT_STRINGS_ACTION(head)
HTML_DOCUMENT_STRINGS_ACTION(link)
/* HTML_DOCUMENT_STRINGS_ACTION(title) */
HTML_DOCUMENT_STRINGS_ACTION(meta)
HTML_DOCUMENT_STRINGS_ACTION(base)
HTML_DOCUMENT_STRINGS_ACTION(isindex)
HTML_DOCUMENT_STRINGS_ACTION(style)
HTML_DOCUMENT_STRINGS_ACTION(body)
HTML_DOCUMENT_STRINGS_ACTION(form)
HTML_DOCUMENT_STRINGS_ACTION(select)
HTML_DOCUMENT_STRINGS_ACTION(optgroup)
HTML_DOCUMENT_STRINGS_ACTION(option)
HTML_DOCUMENT_STRINGS_ACTION(input)
HTML_DOCUMENT_STRINGS_ACTION(textarea)
HTML_DOCUMENT_STRINGS_ACTION(button)
HTML_DOCUMENT_STRINGS_ACTION(label)
HTML_DOCUMENT_STRINGS_ACTION(fieldset)
HTML_DOCUMENT_STRINGS_ACTION(legend)
HTML_DOCUMENT_STRINGS_ACTION(ul)
HTML_DOCUMENT_STRINGS_ACTION(ol)
HTML_DOCUMENT_STRINGS_ACTION(dl)
/* HTML_DOCUMENT_STRINGS_ACTION(dir) */
HTML_DOCUMENT_STRINGS_ACTION(menu)
HTML_DOCUMENT_STRINGS_ACTION(li)
HTML_DOCUMENT_STRINGS_ACTION(blockquote)
HTML_DOCUMENT_STRINGS_ACTION(div)
HTML_DOCUMENT_STRINGS_ACTION(p)
HTML_DOCUMENT_STRINGS_ACTION(h1)
HTML_DOCUMENT_STRINGS_ACTION(h2)
HTML_DOCUMENT_STRINGS_ACTION(h3)
HTML_DOCUMENT_STRINGS_ACTION(h4)
HTML_DOCUMENT_STRINGS_ACTION(h5)
HTML_DOCUMENT_STRINGS_ACTION(h6)
HTML_DOCUMENT_STRINGS_ACTION(q)
HTML_DOCUMENT_STRINGS_ACTION(pre)
HTML_DOCUMENT_STRINGS_ACTION(br)
HTML_DOCUMENT_STRINGS_ACTION(basefont)
HTML_DOCUMENT_STRINGS_ACTION(font)
HTML_DOCUMENT_STRINGS_ACTION(hr)
HTML_DOCUMENT_STRINGS_ACTION(ins)
HTML_DOCUMENT_STRINGS_ACTION(del)
HTML_DOCUMENT_STRINGS_ACTION(a)
HTML_DOCUMENT_STRINGS_ACTION(img)
HTML_DOCUMENT_STRINGS_ACTION(object)
HTML_DOCUMENT_STRINGS_ACTION(param)
HTML_DOCUMENT_STRINGS_ACTION(applet)
HTML_DOCUMENT_STRINGS_ACTION(map)
HTML_DOCUMENT_STRINGS_ACTION(area)
HTML_DOCUMENT_STRINGS_ACTION(script)
HTML_DOCUMENT_STRINGS_ACTION(table)
HTML_DOCUMENT_STRINGS_ACTION(caption)
HTML_DOCUMENT_STRINGS_ACTION(col)
HTML_DOCUMENT_STRINGS_ACTION(colgroup)
HTML_DOCUMENT_STRINGS_ACTION(thead)
HTML_DOCUMENT_STRINGS_ACTION(tfoot)
HTML_DOCUMENT_STRINGS_ACTION(tbody)
HTML_DOCUMENT_STRINGS_ACTION(tr)
HTML_DOCUMENT_STRINGS_ACTION(th)
HTML_DOCUMENT_STRINGS_ACTION(td)
HTML_DOCUMENT_STRINGS_ACTION(frameset)
HTML_DOCUMENT_STRINGS_ACTION(frame)
HTML_DOCUMENT_STRINGS_ACTION(iframe)

#ifdef HTML_DOCUMENT_STRINGS_SUFFIX
HTML_DOCUMENT_STRINGS_SUFFIX
#endif


#ifdef HTML_DOCUMENT_STRINGS_INTERNAL_ACTION
#undef HTML_DOCUMENT_STRINGS_INTERNAL_ACTION
#undef HTML_DOCUMENT_STRINGS_PREFIX
#undef HTML_DOCUMENT_STRINGS_SUFFIX
#undef HTML_DOCUMENT_STRINGS_ACTION
#endif
